package applet.fileviewer;

import java.beans.PropertyChangeEvent;
import java.io.File;

import applet.JSIDPlay2;

@SuppressWarnings("serial")
public class HVSCView extends FileViewer {
	public HVSCView(final JSIDPlay2 sidplay) {
		super(sidplay, "High Voltage SID Collection", "http://www.hvsc.de/", "<Please select HVSC>");
	}

	@Override
	protected void setRootDir(String hvsc) {
		File hvscFile = new File(hvsc);
		if (hvscFile.exists()) {
			fSidplay2.setHVSC(hvsc);
		}
	}

	public void propertyChange(PropertyChangeEvent event) {
		if (JSIDPlay2.PROP_HVSC.equals(event.getPropertyName())) {
			setRoot((String) event.getNewValue());
		}
	}
}