package applet.fileviewer;

import javax.swing.table.AbstractTableModel;

import applet.JSIDPlay2;
import applet.sidtune.SidTuneInfoCache;

public final class TuneInfoTableModel extends AbstractTableModel {

	private final SidTuneInfoCache infoCache;

	private TuneFile tuneFile;

	/**
	 * @param view
	 */
	public TuneInfoTableModel(final JSIDPlay2 sidplay2) {
		infoCache = new SidTuneInfoCache(sidplay2);
	}

	public void setFile(final TuneFile file) {
		this.tuneFile = file;
	}

	@Override
	public boolean isCellEditable(final int rowIndex, final int columnIndex) {
		return false;
	}

	public Object getValueAt(final int rowIndex, final int columnIndex) {
		if (tuneFile == null || tuneFile.isDirectory()) {
			return "";
		}

		if (columnIndex == 0) {
			return SidTuneInfoCache.SIDTUNE_INFOS[rowIndex];
		}
		
		return infoCache.getInfo(tuneFile.getAbsolutePath())[rowIndex];
	}

	public int getRowCount() {
		return SidTuneInfoCache.SIDTUNE_INFOS.length;
	}

	public int getColumnCount() {
		return 2;
	}
}