/**
 * 
 */
package applet.fileviewer;

import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.util.Arrays;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import applet.TuneFileFilter;


public final class TuneTreeModel implements TreeModel {
	/**
	 * file filter for tunes
	 */
	private FileFilter fFileFilter = new TuneFileFilter();
	
	/**
	 * root element
	 */
	private final String fRoot;

	/**
	 * @param view
	 */
	public TuneTreeModel(String rootDir) {
		this.fRoot = rootDir;
	}

	public void valueForPathChanged(TreePath treepath, Object obj) {

	}

	public void removeTreeModelListener(TreeModelListener treemodellistener) {

	}

	public boolean isLeaf(Object obj) {
		if (! (obj instanceof TuneFile)) {
			return false;
		}
		return ((TuneFile) obj).isFile();
	}

	public Object getRoot() {
		try {
			return new TuneFile(new File(fRoot).getCanonicalPath());
		} catch (IOException e) {
			return new File(fRoot).getAbsolutePath();
		}
	}

	public int getIndexOfChild(Object parent, Object child) {
		File[] listFiles = getListOfFiles(parent);
		for (int i = 0; i < listFiles.length; i++) {
			if (listFiles[i].equals(child)) {
				return i;
			}
		}
		return -1;
	}

	public int getChildCount(Object obj) {
		File[] listFiles = getListOfFiles(obj);
		if (listFiles == null) {
			return 0;
		}
		((TuneFile) obj).listFiles = listFiles;
		return listFiles.length;
	}

	public Object getChild(Object obj, int i) {
		try {
			return new TuneFile(((TuneFile) obj).listFiles[i].getCanonicalPath());
		} catch (IOException e) {
			return new TuneFile(((TuneFile) obj).listFiles[i].getAbsolutePath());
		}
	}

	private File[] getListOfFiles(Object obj) {
		File[] listFiles = ((TuneFile) obj).listFiles;
		if (listFiles == null) {
			listFiles = ((TuneFile) obj).listFiles(fFileFilter);
			if (listFiles != null) {
				Arrays.sort(listFiles);
			}
		}
		return listFiles;
	}

	public void addTreeModelListener(TreeModelListener treemodellistener) {

	}
}