package applet.settings;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import applet.JSIDPlay2;

@SuppressWarnings("serial")
public class SIDIcon extends JPanel implements PropertyChangeListener {
	private ImageIcon imageIcon;

	private ImageIcon imageIconR2_4982 = new ImageIcon(JSIDPlay2.class
			.getResource("icons/6581_4982.jpg"));
//	private ImageIcon imageIconR3_2284 = new ImageIcon(JSIDPlay2.class
//			.getResource("icons/6581_2284.jpg"));
	private ImageIcon imageIcon8580_3390 = new ImageIcon(JSIDPlay2.class
			.getResource("icons/8580_3390.jpg"));
	private ImageIcon imageIconR3_1386 = new ImageIcon(JSIDPlay2.class
			.getResource("icons/6581R3_1386.jpg"));
	private ImageIcon imageIconR4AR_4388 = new ImageIcon(JSIDPlay2.class
			.getResource("icons/6581R4AR_4388.jpg"));

	public SIDIcon(JSIDPlay2 sidplay2) {
		sidplay2.support.addPropertyChangeListener(this);
	}

	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;

		if (imageIcon != null) {
			g2.scale(Math.min(1,(double) (getWidth()-40) / imageIcon.getIconWidth()),
					Math.min(1,(double) (getHeight()-40) / imageIcon.getIconHeight()));
			imageIcon.paintIcon(this, g, 20, 20);
		}
	}

	public void propertyChange(PropertyChangeEvent e) {
		if (JSIDPlay2.PROP_FILTER.equals(e.getPropertyName())) {
			String filterName = ((String) e.getNewValue()).toLowerCase();
			if (filterName.indexOf("r4ar") != -1) {
				imageIcon = imageIconR4AR_4388;
			} else if (filterName.indexOf("r4") != -1) {
				imageIcon = imageIconR4AR_4388;
			} else if (filterName.indexOf("r3") != -1) {
				imageIcon = imageIconR3_1386;
			} else if (filterName.indexOf("r2") != -1) {
				imageIcon = imageIconR2_4982;
			} else if (filterName.indexOf("6581") != -1) {
				imageIcon = imageIconR2_4982;
			} else if (filterName.indexOf("8580") != -1) {
				imageIcon = imageIcon8580_3390;
			} else {
				imageIcon = null;
			}
			repaint();
		}
	}

}
