package libsidplay.components.pla;

import libsidplay.components.mos656x.MOS656X;

/**
 * When nobody is supplying real chips for IO1/IO2, the reads read stale
 * bus data from VIC's previous memory interaction.
 * 
 * @author Antti Lankila
 */
public final class DisconnectedBusBank extends Bank {
	private final MOS656X vic;
	public DisconnectedBusBank(MOS656X vic) {
		this.vic = vic;
	}
	
	@Override
	public byte read(int address) {
		return vic.getLastReadByte();
	}

	@Override
	public void write(int address, byte value) {
	}
}
