/**
 *                                  description
 *                                  -----------
 *  begin                : Sat Jul 8 2000
 *  copyright            : (C) 2000 by Simon White
 *  email                : s_a_white@email.com
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * @author Ken Hndel
 *
 */
package sidplay.audio;

import java.io.IOException;
import java.nio.ByteBuffer;

import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

public abstract class AudioDriver {
	protected int fastForward = 1;

	protected boolean stopped;

	// All drivers must support these
	public abstract void open(AudioConfig cfg, String name)
	throws LineUnavailableException, UnsupportedAudioFileException, IOException;

	public abstract void write();

	public abstract void pause();

	public abstract void close();

	public abstract void reset();

	public String extension() {
		return "";
	}

	public abstract ByteBuffer buffer();
	
	public void setFastForward(int factor) {
		fastForward = factor;
	}

	public void stop() {
		stopped = true;
	}
}
